package ru.landgrafhomyak.db.skeleton1.api.module

import ru.landgrafhomyak.db.skeleton1.api.LifeTime
import ru.landgrafhomyak.db.skeleton1.api.ReflectionApi
import ru.landgrafhomyak.db.skeleton1.api.ObjectClass

public interface ModuleScopedObject<pmUE : Any> {
	@ReflectionApi
	public val parentModule: Module<pmUE>

	@ReflectionApi
	public val pathFromParentModuleRoot: List<String>

	@ReflectionApi
	public val objectClassProvider: ObjectClass.ImplementationsProvider

	public val unwrappedModuleScopedObject: ModuleScopedObject<pmUE>

	@ReflectionApi
	public val lifeTime: LifeTime
}