package ru.landgrafhomyak.db.skeleton1.api.table

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.skeleton1.api.LifeTime
import ru.landgrafhomyak.db.skeleton1.api.ReflectionApi
import ru.landgrafhomyak.db.skeleton1.api.ObjectClass

public interface TableScopedObject<tUE : Any> {
	@ReflectionApi
	public val name: String

	@ReflectionApi
	public val parentTable: Table<tUE, *>

	@ReflectionApi
	public val objectClassProvider: ObjectClass.ImplementationsProvider

	@ReflectionApi
	public val lifeTime: LifeTime

	public val unwrappedTableScopedObject: TableScopedObject<tUE>
}